import { OAuthConfig, OAuthUserConfig } from ".";
interface NotionWorkspaceOwner {
    type: "workspace";
    workspace: true;
}
interface NotionUserUser {
    object: "user";
    id: string;
    name: string;
    avatar_url: string;
    type: "person";
    person: {
        email: string;
    };
}
interface NotionBotUser {
    object: "user";
    id: string;
    name: string;
    avatar_url: string;
    type: "bot";
    bot: any;
}
interface NotionUserOwner {
    type: "user";
    user: NotionUserUser | NotionBotUser;
}
export interface NotionResponseFields {
    workspace_name: string;
    workspace_id: string;
    workspace_icon: string;
    bot_id: string;
}
export interface NotionResponse extends NotionResponseFields {
    /**
     * https://developers.notion.com/reference/user#all-users
     * https://developers.notion.com/reference/user#people
     */
    owner: NotionWorkspaceOwner | NotionUserOwner;
}
export declare type NotionProfile = NotionResponseFields & (NotionUserOwner | NotionWorkspaceOwner);
export default function Notion<P extends Record<string, any> = NotionProfile>(options: OAuthUserConfig<P> & {
    /** @default "2021-08-16" */
    notionVersion?: string;
}): OAuthConfig<P>;
export {};
