"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Notion;

function Notion(options) {
  return {
    id: "notion",
    name: "Notion",
    type: "oauth",
    authorization: "https://api.notion.com/v1/oauth/authorize?owner=user",
    token: "https://api.notion.com/v1/oauth/token",
    userinfo: {
      request(params) {
        const tokens = params.tokens;
        const common = {
          workspace_id: tokens.workspace_id,
          workspace_name: tokens.workspace_name,
          workspace_icon: tokens.workspace_icon,
          bot_id: tokens.bot_id,
          ...tokens.owner
        };

        if (tokens.owner.type === "user") {
          const commonUser = { ...common,
            ...tokens.owner.user
          };

          if (tokens.owner.user.type === "person") {
            return { ...commonUser,
              ...tokens.owner.user.person
            };
          }

          return { ...commonUser,
            ...tokens.owner.user.bot
          };
        }

        return {
          id: tokens.bot_id,
          ...common,
          ...tokens.owner
        };
      }

    },

    profile(profile) {
      return {
        id: profile.id,
        name: profile.name,
        email: profile.email,
        image: profile.avatar_url
      };
    },

    checks: ["state"],
    options
  };
}