import { TokenSet } from "openid-client";
import { Account, LoggerInstance, Profile } from "src";
import { OAuthConfig } from "src/providers";
export default function oAuthCallback(req: any, res: any): Promise<GetProfileResult>;
export interface GetProfileParams {
    profile: Profile;
    tokens: TokenSet;
    provider: OAuthConfig<any>;
    logger: LoggerInstance;
}
export interface GetProfileResult {
    profile: ReturnType<OAuthConfig["profile"]> | null;
    account: Omit<Account, "userId"> | null;
    OAuthProfile: Profile;
}
