import { NextAuthOptions } from "../..";
import { InternalOptions } from "../../lib/types";
/**
 * Takes a number in seconds and returns the date in the future.
 * Optionally takes a second date parameter. In that case
 * the date in the future will be calculated from that date instead of now.
 */
export declare function fromDate(time: any, date?: number): Date;
export declare function hashToken(token: string, options: InternalOptions<"email">): string;
/**
 * Secret used salt cookies and tokens (e.g. for CSRF protection).
 * If no secret option is specified then it creates one on the fly
 * based on options passed here. A options contains unique data, such as
 * OAuth provider secrets and database credentials it should be sufficent.
 */
export default function createSecret({ userOptions, basePath, baseUrl, }: {
    userOptions: NextAuthOptions;
    basePath: string;
    baseUrl: string;
}): string;
